<template>
  <div class="offers-tab">
    <ObTable
      ref="offers-table"
      :columns="columns"
      :remote-opt="{
        method: getOffersByFilterTab,
        arguments: {
          tenderUuid: tender.uuid,
          requestUuid: tender.requestUuid
        },
        contentKey: getRequestContentKey
      }"
      :functional-panel="true"
      :table-layout-fixed="false"
      :show-hidden-length="true"
      :filter-buttons="filterButtons"
      :is-functional-group="false"
      :is-functional-sort="false"
      :is-functional-search="false"
      :class="[ 'offers-table', viewFilter ? viewFilter.toLowerCase() : '' ]"
      :filters-handler="filtersHandler"
      data-qa="offersTable"
      @on-change-filter-button="onChangeFilterButton"
      @on-load-list="onTableDataLoaded"
      @select="onSelect"
      is-fixed-header
    >
      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>

      <template slot="noneContent">
        <span class="title">
          Пока здесь нет предложений от участников
        </span>
      </template>
    </ObTable>

    <!-- <ob-modal
      ref="filter-contractors-modal"
      :title="`Поставщики тендера «${ tender.name }»`"
      size="max"
      cancelText="Закрыть"
      :isShowControls="true"
      :isReadOnly="true"
    >
      <ob-table
        :columns="filterContractorsColumns"
        :items="items"
        :functionalPanel="true"
        :tableLayoutFixed="false"
      >
        <div slot="checkbox" slot-scope="{ data }">
          <div @click.stop>
            <ob-checkbox
              v-model="data.item.checked"
            />
          </div>
        </div>
      </ob-table>
    </ob-modal> -->

    <ObModal
      v-if="selectedData"
      ref="contractors-modal"
      :title="viewFilterModalTitle"
      size="max"
      cancel-text="Закрыть"
      :is-show-controls="true"
      :is-read-only="true"
    >
      <div class="modal-info-header">
        <div class="modal-heading">Участвует в лотах: <span>{{ selectedData.partTakeLotsCount }}</span></div>
        <div class="modal-heading">Не участвует в лотах: <span>{{ selectedData.noPartTakeLotsCount }}</span></div>
        <div class="modal-heading">Лотов с гарантированным объемом: <span>{{ selectedData.guaranteedPurchaseVolumeLotsCount }}</span></div>
        <div class="modal-heading">Дефицитных лотов: <span>{{ selectedData.deficitLotsCount }}</span></div>
      </div>

      <ObTable
        ref="contractors-table"
        :columns="byContractorsColumns"
        :remote-opt="{
          method: api.tenders.getRFQTenderCarrierOffersByUuids,
          arguments: {
            tenderUuid: tender.uuid,
            requestUuid: tender.requestUuid,
            carrierUuid: selectedData.uuid
          },
          contentKey: 'lots'
        }"
        :functional-panel="true"
        :is-functional-sort="false"
        :is-functional-group="false"
        :table-layout-fixed="false"
        class="modal-table"
        @on-load-list="onModalTableDataLoaded"
      />
    </ObModal>

    <ObModal
      v-if="selectedData"
      ref="lots-modal"
      :title="viewFilterModalTitle"
      size="max"
      cancel-text="Закрыть"
      :is-show-controls="true"
      :is-read-only="true"
    >
      <div class="modal-info-header">
        <div class="modal-heading">Индикатор дефицита: <span>{{ selectedData.deficitIndicator }}</span></div>
        <div class="modal-heading">Вес лота: <span>{{ selectedData.lotWeight }} %</span></div>
        <div class="modal-heading">Min ставка: <span>{{ selectedData.minBid }} ₽</span></div>
        <div class="modal-heading">Max ставка: <span>{{ selectedData.maxBid }} ₽</span></div>
        <div class="modal-heading">Средняя ставка: <span>{{ selectedData.averageBid }} ₽</span></div>
      </div>

      <ObTable
        ref="lots-table"
        :columns="byLotsColumns"
        :remote-opt="{
          method: api.tenders.getRFQTenderParticipantsByUuidsAndOffers,
          arguments: {
            tenderUuid: tender.uuid,
            lotUuid: selectedData.uuid
          },
          contentKey: 'offers'
        }"
        :functional-panel="true"
        :table-layout-fixed="false"
        :is-functional-sort="false"
        :is-functional-group="false"
        class="modal-table"
        @on-load-list="onModalTableDataLoaded"
      />
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </div>
</template>

<script>
  import { rfq_columns } from './data.js';

  import api from '@/api';
  import ExportExcel from '../../mixins/export-excel'
  import FiltersSupport from '../../../../mixins/filtersSupport'

  import ObTable from 'common-components/src/obComponents/obTable';
  import ObModal from 'common-components/src/obComponents/obModal';

  export default {
    name: "tender-tab-buyer-offers-rfq",
    mixins: [
      ExportExcel,
      FiltersSupport
    ],
    components: {
      ObTable,
      ObModal
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    computed: {
      getRequestContentKey: ({ viewFilter }) => {
        switch (viewFilter) {
          case 'all':
            return 'offers'
          case 'lots':
            return 'lots'
          case 'contractors':
            return 'carriers'
        }
      },
      // contractors: ({ items }) => items.map(item => item.contractor),
      // filteredItems: ({ items }) => items.filter(item => item.checked),
      selectedContractorsText() {
        // return this.filteredItems.length !== this.items.length ? 'Выбрано: ' + this.filteredItems.length : 'Все'
        return 'Все'
      }
    },
    data() {
      return {
        api,
        viewFilter: null,
        columns: [],
        checklists: [],
        filterButtons: [
          {
            title: 'Все предложения',
            relates: 'all'
          },
          {
            title: 'По лотам',
            relates: 'lots'
          },
          {
            title: 'По поставщикам',
            relates: 'contractors'
          }
        ],
        filterButtonWasChanged: false,
        viewFilterModalTitle: '',
        selectedData: null,
        filterContractorsColumns: [
          {
            title: 'Выбор',
            headerHtml: () => '',
            slotName: 'checkbox',
            width: 40,
          },
          {
            title: 'Название контрагента',
            html: ({ contractor }) => contractor.title
          }
        ],
        byLotsColumns: [],
        byContractorsColumns: []
      }
    },
    async created() {
      await this.getOffersChecklists();

      this.onChangeFilterButton({ relates: 'all' });

      this.columns = [...rfq_columns[this.viewFilter]];
    },
    methods: {
      async getOffersChecklists() {
        this.checklists = await api.tenders.getLotsChecklists(this.tender.requestUuid);
      },
      async getOffersByFilterTab(args) {
        let response = null;

        switch (this.viewFilter) {
          case 'all': {
            response = await api.tenders.getRFQTenderOffersByUuids({ ...args, ...this.tableParameters });

            return response;

          }
          case 'lots':
            response = await api.tenders.getRFQTenderOffersByUuidsAndLots({ ...args, ...this.tableParameters });

            return response;

          case 'contractors':
            response = await api.tenders.getRFQTenderOffersByUuidsAndCarriers({
              ...args,
              query: this.tableParameters.carrierTitle
            });

            return response;

          default:
            return [];
        }
      },
      getHTMLValue(value) {
        const uuidPattern = /^[0-9a-f]{8}-[0-9a-f]{4}-[0-5][0-9a-f]{3}-[089ab][0-9a-f]{3}-[0-9a-f]{12}$/i;

        if (uuidPattern.test(value)) {
          const header = this.checklists.headers.find((header) => {
            return header.options.some(option => option.uuid === value)
          })

          return header.options.find(option => option.uuid === value).title;
        } else if (typeof value === "boolean") {
          return value ? 'Да' : 'Нет';
        } else {
          return value;
        }
      },
      loadData(refName) {
        this.$nextTick(() => {
          this.$refs[refName].loadData({ init: true });
        })
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.RFQOffers(this.tender.uuid, this.tender.requestUuid)
      },
      // 👂 Events
      onSelect(e) {
        this.selectedData = e;

        const findValue = (headerKey, title) => e.lotHeaders.find(header => header[headerKey] === title).value

        switch (this.viewFilter) {
          case 'lots': {
            const header = this.checklists.headers.find(h => h.options.some(o => o.uuid === findValue('title', 'Тип ТС')))
            const type = header.options.find(o => o.uuid === findValue('title', 'Тип ТС')).title

            this.viewFilterModalTitle = `
              ${findValue('categoryTitle', 'Место отправления')} →
              ${findValue('categoryTitle', 'Место назначения')} /
              ${type} / ${findValue('title', 'Грузоподъемность (Тонн)')}
            `;

            this.$nextTick(() => {
              this.$refs['lots-modal'].open();
              this.$nextTick(() => this.loadData('lots-table'));
            });

            break;
          }

          case 'contractors':
            this.viewFilterModalTitle = e.title;

            this.$nextTick(() => {
              this.$refs['contractors-modal'].open();
              this.$nextTick(() => this.loadData('contractors-table'));
            });

            break;
        }
      },
      onChangeFilterButton({ relates }) {
        this.filterButtonWasChanged = this.viewFilter !== relates;
        this.viewFilter = relates;

        const sort = this.$refs['offers-table'].$children[1]?.sort

        if (sort) {
          sort.key = null;
          sort.type = null;
        }

        this.loadData('offers-table');
      },
      parseColumns (headers, dataKey, isConcat = true, isHeaderHtml = true) {
        const columns = headers
          .sort((a, b) => a.categoryPos - b.categoryPos || a.category?.pos - b.category?.pos || a.pos - b.pos)
          .map(header => {
            return  {
              title: header.title,
              key: header.uuid,
              isAlignRight: typeof header.value === 'number',
              html: (data) => this.getHTMLValue(data[dataKey].find(h => h.uuid === header.uuid).value),
              ...(['locality_from', 'locality_to'].includes(header.code) && { withFilter: true }),
              ...(isHeaderHtml && { headerHtml: () => `<div class="text-gray">${header.categoryTitle || header.category?.title || ''}</div>${header.title}` })
            }
          })

        if (isConcat) {
          this.columns = this.columns.concat(columns)
        } else {
          return columns
        }
      },
      async onTableDataLoaded(data) {
        if (!this.filterButtonWasChanged || !data.length) {
          return
        }

        this.filterButtonWasChanged = false;

        this.columns = [...rfq_columns[this.viewFilter]];

        switch (this.viewFilter) {
          case 'all': {
            const dynamicColumns = data[0];

            // refactor to single array and sort by categoryPos if
            // categoryPos is common for both lotHeaders and offerHeaders
            if (dynamicColumns) {
              this.parseColumns(dynamicColumns.lotHeaders, 'lotHeaders');
              this.parseColumns(dynamicColumns.offerHeaders, 'offerHeaders');

              // add column right after lotHeaders last column
              this.columns.splice(dynamicColumns.lotHeaders.length + 1, 0, {
                title: 'Поставщик',
                key: 'carrierTitle',
                withFilter: true
              });
            }

            break;
          }

          case 'lots': {
            const dynamicColumns = this.$refs['offers-table'].localItems[0];

            if (dynamicColumns) {
              this.parseColumns(dynamicColumns.lotHeaders, 'lotHeaders');
            }

            break;
          }
        }
      },
      async onModalTableDataLoaded() {
        switch (this.viewFilter) {
          case 'lots': {
            const headers = this.$refs['lots-table'].localItems[0].headers;

            if (headers && headers.length) {
              this.byLotsColumns = this.parseColumns(headers, 'headers', false, false)
            }

            this.byLotsColumns.unshift({
              title: 'Поставщик',
              key: 'carrierTitle'
            })

            break;
          }

          case 'contractors': {
            const headers = this.$refs['contractors-table'].localItems[0].headers;

            if (headers && headers.length) {
              this.byContractorsColumns = this.parseColumns(headers, 'headers', false)
            }

            // this.byContractorsColumns.push({
            //   title: 'Коммент. пост-ка',
            //   html: ({ comment }) => comment ? `<div class="offer-comment-wrapper"><i class="icon event"></i><div class="offer-comment">${comment}</div></div>` : ''
            // })

            break;
          }
        }
      },
      onChooseContractors() {
        // this.$refs['filter-contractors-modal'].open();
      },
      reloadTable () {
        this.loadData('offers-table')
      }
    }
  };
</script>

<style lang="scss">
  .offer-comment-wrapper {
    position: relative;

    &:hover {
      color: $color-blue-navy-blue;

      .offer-comment {
        opacity: 1;
        pointer-events: all;
      }
    }

    i.event {
      font-size: 18px;
      color: $color-blue-navy-blue;
      position: relative;
      top: 3px;
    }
  }

  .offer-comment {
    position: absolute;
    top: 0;
    right: 0;
    pointer-events: none;
    background: $background-white;
    z-index: 100;
    padding: 8px 12px;
    width: 200px;
    border-radius: 2px;
    box-sizing: border-box;
    box-shadow: 0 0 8px rgba($color-blue-navy-blue, .4);
    transform: translate(10px, 30px);
    opacity: 0;
    color: $tendersPage-buyer_offer_comment;

    a {
      color: $color-blue-navy-blue;
    }

    &::before {
      content: '';
      position: absolute;
      right: 15px;
      top: -10px;
      border: 5px solid transparent;
      border-bottom: 5px solid $tendersPage-buyer_offer_comment_border_bottom_before;
    }

    &::after {
      content: '';
      position: absolute;
      width: 100%;
      left: 0;
      top: -25px;
      height: 25px;
    }
  }

  .table-data tr {
    &:nth-last-child(1),
    &:nth-last-child(2) {
      .offer-comment {
        transform: translate(10px, calc(-100% - 5px));

        &::before {
          top: auto;
          bottom: -10px;
          border: 5px solid transparent;
          border-top: 5px solid $tendersPage-buyer_offer_comment_border_bottom_before;
        }

        &::after {
          top: auto;
          bottom: -25px;
        }
      }
    }
  }
</style>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  /deep/ {
    .text-gray {
      color: $color-grey-span;
    }

    .td-container {
      word-break: normal;
    }
  }

  .ob-select-imitation {
    border: 1px solid $color-grey-border;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    justify-content: space-between;
    padding: 7px 35px 7px 11px;
    height: 52px;
    background: $background-white;
    border-radius: 3px;
    position: relative;
    cursor: pointer;

    label {
      @include font-mixin(12px, normal, 400, $color-grey-label, 0.4px);
    }

    .fake-data {
      @include font-mixin(16px, 20px, 400, $color-text-base);
    }

    .icon {
      position: absolute;
      right: 7px;
      top: 0;
      bottom: 0;
      margin: auto;
      font-size: 30px;
      height: 30px;
      color: $color-blue-navy-blue;
    }
  }

  .modal-info-header {
    display: flex;
    align-items: flex-start;
    margin-bottom: 20px;
  }

  .modal-heading {
    @include font-mixin(14px, 18px, 400, $gray-slate);

    margin-right: 30px;

    span {
      color: $tendersPage-modal_heading_span;
    }
  }

  .modal-table {
    border: 1px solid $lavender;
  }
</style>
